package meerkat.crypto.dkg.gjkr;

import meerkat.crypto.secretsharing.shamir.Polynomial;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Set;

/**
 * Created by Tzlil on 3/16/2016.
 *
 * an extension of DistributedKeyGenerationParty
 * contains all relevant information on specific party during
 * the run of the safe protocol
 */
public class Party<T> extends meerkat.crypto.dkg.feldman.Party<T> {
    public Polynomial.Point shareT;
    public boolean ysDoneFlag;
    public ArrayList<T> verifiableValues;
    public Set<Polynomial.Point> recoverSharesSet;
    public Party(int id, int n, int t) {
        super(id, n, t);
        this.shareT = null;
        this.ysDoneFlag = false;
        this.verifiableValues = new ArrayList<T>(this.commitments);
        this.recoverSharesSet = new HashSet<Polynomial.Point>();
    }
}
